;==============================================================================
;
; Module:          frmImport.au3
; Description:     Allows a user to login to the system, 
;                  If the Servers, Database or Users tables have no data,
;                  the Login ID must be Supervisor with a password of TEBSchemes.
;                  Only the Supervisor can change the setup options.
; Parameters:      $gLogin - the Login ID stored as a Global name
; Requirement(s):  A TEBSchemes.db SQLite database
;                  A MS-SQL 2000 database with OLEDB drivers for MS-SQL and 
;                  MS-Excel.
; Return Value(s): true - Login passed or false - login failed 
; Author(s):       DJ van Vliet
; Note(s):         The SQLite.dll file is included in the .exe file.
;                  A SQLite file containing the set-up values is created in 
;                  the same directory as the TEBSchemes.exe file
;                  The User ID's and their 'rights' are created/modified
;                  Raised and Payment Paths (per RaisedGroup) can be entered
;                  A table of Raised dates, UserID and Date, Time and the full
;                  path of the exported file. 
;==============================================================================

Func CreateForm_frmImport(ByRef $afrmNew, $frmParent)
	Dim $afrmNew[20][2]

  $afrmNew[0][0] = "$frmImport"
	$afrmNew[0][1] = GUICreate("SAVVEM Import", 383, 324, -1, -1, -1, -1, $frmParent)

	$afrmNew[1][0] = "$frmParent"
	$afrmNew[1][1] = $frmParent
	
  GUICtrlCreateGroup("Master Files", 15, 20, 166, 146)
  GUICtrlCreateGroup("Look up Tables", 200, 20, 166, 146)

	$afrmNew[2][0] = "$rbClients"
	$afrmNew[2][1] = GUICtrlCreateRadio("Client", 41, 37, 113, 17)
  GUICtrlSetState(-1, $GUI_CHECKED)
	$afrmNew[3][0] = "$rbAccounts"
	$afrmNew[3][1] = GUICtrlCreateRadio("Master Account", 41, 54, 113, 17)

	$afrmNew[4][0] = "$rbAccMembers"
	$afrmNew[4][1] = GUICtrlCreateRadio("Master Members", 41, 72, 113, 17)
	$afrmNew[5][0] = "$rbPolicies"
	$afrmNew[5][1] = GUICtrlCreateRadio("Policy Master", 41, 88, 113, 17)
	$afrmNew[6][0] = "$rbPolicyTx"
	$afrmNew[6][1] = GUICtrlCreateRadio("Policy Transactions", 41, 105, 113, 17)
	$afrmNew[7][0] = "$rbPayExp"
	$afrmNew[7][1] = GUICtrlCreateRadio("Pay Expenses", 41, 122, 113, 17)
	$afrmNew[8][0] = "$rbSavvemRates"
	$afrmNew[8][1] = GUICtrlCreateRadio("SAVVEM Rates", 226, 37, 113, 17)
	$afrmNew[9][0] = "$rbSetID"
	$afrmNew[9][1] = GUICtrlCreateRadio("Set ID NONVW", 226, 54, 113, 17)
	$afrmNew[10][0] = "$rbAccountStatus"
	$afrmNew[10][1] = GUICtrlCreateRadio("Account Status", 226, 72, 113, 17)
	$afrmNew[11][0] = "$rbAddressTypes"
	$afrmNew[11][1] = GUICtrlCreateRadio("Address Type", 226, 88, 113, 17)
	$afrmNew[12][0] = "$rbEffectiveStatus"
	$afrmNew[12][1] = GUICtrlCreateRadio("Effective Status", 226, 105, 113, 17)
	$afrmNew[13][0] = "$rbProducts"
	$afrmNew[13][1] = GUICtrlCreateRadio("Products", 226, 122, 113, 17)
	$afrmNew[14][0] = "$rbTxTypes"
	$afrmNew[14][1] = GUICtrlCreateRadio("Transaction Types", 226, 139, 113, 17)
  GUICtrlCreateLabel("Importing to: ", 15, 185, 65, 17)
	$afrmNew[15][0] = "$inpTable"
	$afrmNew[15][1] = GUICtrlCreateInput("", 85, 180, 281, 21, -1, $WS_EX_CLIENTEDGE)
  GUICtrlSetState(-1, $GUI_DISABLE)
	$afrmNew[16][0] = "$cbxHeaders"
	$afrmNew[16][1] = GUICtrlCreateCheckbox("First line of file contains column headers", 15, 215, 331, 21)
  GUICtrlSetState(-1, $GUI_CHECKED)
	$afrmNew[17][0] = "$cbxDelete"
	$afrmNew[17][1] = GUICtrlCreateCheckbox("Delete current records before importing data?", 15, 243, 331, 21)
	$afrmNew[18][0] = "$btnImport"
	$afrmNew[18][1] = GUICtrlCreateButton("&Import", 15, 284, 106, 26)
	$afrmNew[19][0] = "$btnClose"
	$afrmNew[19][1] = GUICtrlCreateButton("Close", 260, 284, 106, 26)
EndFunc

Func frmImport_WndProc()
	
	
	Select
		Case $msg[0] = $GUI_EVENT_CLOSE
			GUISwitch(_GetCtrl("$frmParent", $afrmImport))
			GUISetState(@SW_ENABLE)
			GUISwitch($afrmImport[0][1])
			GUISetState(@SW_HIDE)
		Case $msg[0] = _GetCtrl("$btnClose", $afrmImport)
			$msg[0] = $GUI_EVENT_CLOSE
			frmImport_WndProc()
		Case $msg[0] = _GetCtrl("$btnImport", $afrmImport)
			frmImport_btnImport_Click()
;			$msg[0] = $GUI_EVENT_CLOSE
;			frmImport_WndProc()

		Case $msg[0] = _GetCtrl("$rbClients", $afrmImport)
			GUICtrlSetData(_GetCtrl("$inpTable", $afrmImport),"Clients")
		Case $msg[0] = _GetCtrl("$rbAccounts", $afrmImport)
			GUICtrlSetData(_GetCtrl("$inpTable", $afrmImport),"Accounts")
		Case $msg[0] = _GetCtrl("$rbAccMembers", $afrmImport)
			GUICtrlSetData(_GetCtrl("$inpTable", $afrmImport),"AccMembers")
		Case $msg[0] = _GetCtrl("$rbPolicies", $afrmImport)
			GUICtrlSetData(_GetCtrl("$inpTable", $afrmImport),"Policies")
		Case $msg[0] = _GetCtrl("$rbPolicyTx", $afrmImport)
			GUICtrlSetData(_GetCtrl("$inpTable", $afrmImport),"PolicyTx")
		Case $msg[0] = _GetCtrl("$rbPayExp", $afrmImport)
			GUICtrlSetData(_GetCtrl("$inpTable", $afrmImport),"PayExpense")
		Case $msg[0] = _GetCtrl("$rbSavvemRates", $afrmImport)
			GUICtrlSetData(_GetCtrl("$inpTable", $afrmImport),"SavvemRates")
		Case $msg[0] = _GetCtrl("$rbSetID", $afrmImport)
			GUICtrlSetData(_GetCtrl("$inpTable", $afrmImport),"BranchNONVW")
		Case $msg[0] = _GetCtrl("$rbAccountStatus", $afrmImport)
			GUICtrlSetData(_GetCtrl("$inpTable", $afrmImport),"AccountStatus")
		Case $msg[0] = _GetCtrl("$rbAddressTypes", $afrmImport)
			GUICtrlSetData(_GetCtrl("$inpTable", $afrmImport),"AddressTypes")
		Case $msg[0] = _GetCtrl("$rbEffectiveStatus", $afrmImport)
			GUICtrlSetData(_GetCtrl("$inpTable", $afrmImport),"EffStatus")
		Case $msg[0] = _GetCtrl("$rbProducts", $afrmImport)
			GUICtrlSetData(_GetCtrl("$inpTable", $afrmImport),"Products")
		Case $msg[0] = _GetCtrl("$rbTxTypes", $afrmImport)
			GUICtrlSetData(_GetCtrl("$inpTable", $afrmImport),"TxTypes")				
    EndSelect

EndFunc

Func frmImport_Initialize()
	GUICtrlSetData(_GetCtrl("$inpTable", $afrmImport),"Clients")
EndFunc


Func frmImport_btnImport_Click()
	Local $flPath, $nStartLine, $aTemp, $sImportTable, $nProgress, $retCode, $sqlString
		
	$flPath = FileOpenDialog("Select CSV File", @ScriptDir, "comma seperated values (*.csv;*.txt)", 1)
	
	If @error Then
			MsgBox(4096, "", "No File(s) chosen")
	Else
		_FileReadToArray($flPath, $aCSV)  ;Copy text to Array in memory
		;Check if current records are to be deleted
		$sImportTable = StringStripWS(GUICtrlRead(_GetCtrl("$inpTable", $afrmImport)),8) ;all spaces

		If GUICtrlRead(_GetCtrl("$cbxDelete", $afrmImport)) = $GUI_CHECKED Then
			;Truncate table $inpTable
			$sqlString = "delete from " & $sImportTable
;																	ConsoleWrite('@@ Debug(158) : $sqlString = ' & $sqlString & @lf & '>Error code: ' & @error & @lf) ;### Debug Console
			$retCode = _SQLite_Exec ($hSQLite, $sqlString) ; INSERT Data
		EndIf
		$nStartLine = 1 ;Default - no headers
		if GUICtrlRead(_GetCtrl("$cbxHeaders", $afrmImport)) = $GUI_CHECKED Then  ; test if File has column headers start at line 2
			$nStartLine = 2
		EndIf
		
		;Progress Bar
		ProgressOn("Progress Meter", "Importing", "0 percent")

		$retCode = _SQLite_Exec(-1, "BEGIN TRANSACTION")
		
		For $i = $nStartLine To UBound($aCSV) - 1
			If StringLen(StringStripWS($aCSV[$i],8))>0 Then
				
				$aTemp = StringSplit(StringRegExpReplace(StringRegExpReplace($aCSV[$i],'"',''),"'","''"), ";")  ; Splits line by Semi-Colon
				
				$sqlString = "insert into " & $sImportTable & " values(" 
				
				Switch $sImportTable
					Case "Clients" 
						;Only import clients with an AddTpe of 'CORR'
						If $aTemp[7] = "CORR" Then
							If StringLen($aTemp[4]) > 0 Then 
								FixDate($aTemp[4]) 
							Else 
								$aTemp[4]='00000000' 
							EndIf
							;No Ethnic Group
							$sqlString &= "'" & $aTemp[1] & "','"  
							If StringLen(StringStripWS($aTemp[2],1)) = 0 Then 
								$sqlString &= " "
							Else
								$sqlString &= StringStripWS($aTemp[2],1)
							EndIf
							$sqlString &= "','" & $aTemp[3] & "','" 
							$sqlString &= $aTemp[4] & "','" & $aTemp[5] & "','" & $aTemp[7] & "','" & $aTemp[8] & "','" 
							$sqlString &= $aTemp[9] & "','" & $aTemp[10] & "','" & $aTemp[11] & "','" & $aTemp[12] & "');"
						Else
							$sqlString = ""
						EndIf
						Case "Accounts" 
							If StringLen($aTemp[3]) > 0 Then 
								FixDate($aTemp[3]) 
							Else 
								$aTemp[3]='00000000' 
							EndIf
							If StringLen($aTemp[11]) > 0 Then 
								FixDate($aTemp[11]) 
							Else 
								$aTemp[11]='00000000' 
							EndIf
							If StringLen($aTemp[12]) > 0 Then 
								FixDate($aTemp[12]) 
							Else 
								$aTemp[12]='00000000' 
							EndIf
							If StringLen($aTemp[13]) > 0 Then 
								FixDate($aTemp[13]) 
							Else 
								$aTemp[13]='00000000' 
							EndIf
							If StringLen($aTemp[16]) > 0 Then 
								FixDate($aTemp[16]) 
							Else 
								$aTemp[16]='00000000' 
							EndIf

							;Set up SQL Statement
							$sqlString &= "'" & $aTemp[1] & "','" & $aTemp[2] & "','" & $aTemp[3] & "',"
							$sqlString &= $aTemp[4] & ",'" & $aTemp[5] & "','" & $aTemp[6] & "','" & $aTemp[7] & "','" & $aTemp[8] & "'," 
							$sqlString &= $aTemp[9] & "," & $aTemp[10] & ",'" & $aTemp[11] & "','" & $aTemp[12] & "','" & $aTemp[13] & "','" 
							$sqlString &= $aTemp[14] & "','" & $aTemp[15] & "','" & $aTemp[16] & "','" & $aTemp[18] & "','" & $aTemp[19] & "');" 
					Case "AccMembers" 
						If StringLen($aTemp[3]) > 0 Then 
							FixDate($aTemp[3]) 
						Else 
							$aTemp[3]='00000000' 
						EndIf
						;Set up SQL Statement
						$sqlString &= "'" & $aTemp[1] & "','" & $aTemp[2] & "','" &$aTemp[3] & "'," &$aTemp[4] & ",'" 
						$sqlString &= $aTemp[5] & "'," & $aTemp[6] & ",'" & $aTemp[7] & "','" & $aTemp[8] & "');"
						
					Case "AddressTypes" 
						$sqlString &= "'" & $aTemp[2] & "','"  & $aTemp[3] & "')"

					Case "AccountStatus" 
						$sqlString &= "'" & $aTemp[2] & "','"  & $aTemp[3] & "')"
						
					Case "EffStatus" 
						$sqlString &= "'" & $aTemp[2] & "','"  & $aTemp[3] & "')"
						
					Case "PayExpense" 
						If StringLen($aTemp[3]) > 0 Then 
							FixDate($aTemp[3]) 
						Else 
							$aTemp[3]='00000000' 
						EndIf
						If StringLen($aTemp[8]) > 0 Then 
							FixDate($aTemp[8]) 
						Else 
							$aTemp[8]='00000000' 
						EndIf
						$sqlString &= "'" & $aTemp[1] & "','" & $aTemp[2] & "','" & $aTemp[3] & "','"
						$sqlString &= $aTemp[4] & "'," & $aTemp[5] & ",'" & $aTemp[6] & "','" & $aTemp[7] & "','" & $aTemp[8] & "'," 
						$sqlString &= $aTemp[9] & "," & $aTemp[10] & ");" 
						
					Case "Policies" 
						If StringLen($aTemp[2]) > 0 Then 
							FixDate($aTemp[2]) 
						Else 
							$aTemp[2]='00000000' 
						EndIf
						If StringLen($aTemp[12]) > 0 Then 
							FixDate($aTemp[12]) 
						Else 
							$aTemp[12]='00000000' 
						EndIf
						$sqlString &= "'" & $aTemp[1] & "','" & $aTemp[2] & "'," & $aTemp[3] & ",'"
						$sqlString &= $aTemp[4] & "','" & $aTemp[5] & "','" & $aTemp[6] & "','" & $aTemp[7] & "','" & $aTemp[8] & "'," 
						$sqlString &= $aTemp[9] & "," & $aTemp[10] & "," & $aTemp[11] & ",'" & $aTemp[12] & "');" 
						
					Case "PolicyTx" 
						If StringLen($aTemp[2]) > 0 Then 
							FixDate($aTemp[2]) 
						Else 
							$aTemp[2]='00000000' 
						EndIf
						If StringLen($aTemp[4]) > 0 Then 
							FixDate($aTemp[4]) 
						Else 
							$aTemp[4]='00000000' 
						EndIf
						$sqlString &= "'" & $aTemp[1] & "','" & $aTemp[2] & "'," & $aTemp[3] & ",'"
						$sqlString &= $aTemp[4] & "','" & $aTemp[5] & "'," & $aTemp[6] & "," & $aTemp[7] & "," & $aTemp[8] & "," 
						$sqlString &= $aTemp[9] & ");" 
						
					Case "SAVVEMRates" 
						FixDate($aTemp[4])
						$sqlString &= $aTemp[1] & ","  & $aTemp[2] & ","  & $aTemp[3] & ",'" & $aTemp[4] & "','" & $aTemp[5] & "'," & $aTemp[6] & ");"
						
					Case "BranchNONVW" 
						$sqlString &= "'" & $aTemp[1] & "','"  & $aTemp[2] & "')"
						
					Case "TxTypes" 
						$sqlString &= "'" & $aTemp[2] & "','"  & $aTemp[3] & "')"
						
					Case "Products" 
						$sqlString &= $aTemp[1] & "','"  & $aTemp[2] & "','"  & $aTemp[3] & "')"
						
				EndSwitch
				;Execute Statement if StringLen($sqlString)>0  allow for records to be skipped
				If StringLen($sqlString) > 0 Then
					$retCode = _SQLite_Exec ($hSQLite, $sqlString) ; INSERT Data
					If $retCode >0 and @Compiled = 0 Then
						ConsoleWrite('@@ Debug(286) : $sqlString = ' & $sqlString & @lf & '>Error code: ' & @error & @lf) ;### Debug Console
						ConsoleWrite('@@ Debug(286) : $retCode = ' & $retCode & @lf & '>Error code: ' & @error & @lf) ;### Debug Console
					EndIf
				EndIf
				$nProgress += 1
				;Progress Bar
				ProgressSet( ($nProgress * 100)/$aCSV[0], StringFormat("%.f", ($nProgress * 100)/$aCSV[0]) & " percent")
				
			EndIf
		Next
		$retCode = _SQLite_Exec(-1, "COMMIT TRANSACTION")
		ProgressSet(100 , "Done", "Complete")
		sleep(500)
		ProgressOff()
		
		MsgBox(0,"SAVVEM Import", "Import Complete!")	
				
	EndIf
;	Landbank_UpdateStausbar()

EndFunc


