;==============================================================================
;
; Module:          frmRelease.au3
; Description:     Displays the Released Transaction results.
; Parameters:      None
; Requirement(s):  A Landbank.db SQLite database
;                  OLEDB drivers for MS-Excel.
; Return Value(s): None 
; Author(s):       DJ van Vliet
; Note(s):          
;==============================================================================

;Global variables for Release Transactions
Global $gRelNoClients, $gRelPercOSCap, $gRelClientBalOfCap, $gRelCapTakenOver
Global $gRelReleaseClientNewCap, $gRelReleasedClientCap, $gRelClientRemainingCap
Global $gRelPremOfReleasedClient, $gRelDaysToRelease 

Func CreateForm_frmRelease(ByRef $afrmNew, $frmParent)
	Dim $afrmNew[41][2]

  $afrmNew[0][0] = "$frmRelease"
	$afrmNew[0][1] = GUICreate("Released Person", 783, 518, -1, -1, -1, -1, $frmParent)

	$afrmNew[1][0] = "$frmParent"
	$afrmNew[1][1] = $frmParent

	GUICtrlCreateGroup("Loan Account Details", 5, 10, 396, 151)
	GUICtrlSetFont(-1, 8, 800, 0, "MS Sans Serif")
	GUICtrlCreateLabel("Account", 40, 35, 44, 17)
  $afrmNew[2][0] = "$inpLoanAccount"
  $afrmNew[2][1] = GUICtrlCreateInput("003/16020", 130, 30, 91, 21, BitOR($ES_CENTER,$ES_READONLY), $WS_EX_CLIENTEDGE)
	GUICtrlCreateLabel("Product", 40, 60, 41, 17)
  $afrmNew[3][0] = "$inpProduct"
  $afrmNew[3][1] = GUICtrlCreateInput("000056", 130, 55, 51, 21, BitOR($ES_RIGHT,$ES_READONLY), $WS_EX_CLIENTEDGE)
	GUICtrlCreateLabel("Term (Years)", 220, 60, 64, 17)
  $afrmNew[4][0] = "$inpTerm"
  $afrmNew[4][1] = GUICtrlCreateInput("25", 310, 55, 31, 21,BitOR($ES_RIGHT,$ES_READONLY), $WS_EX_CLIENTEDGE)
	GUICtrlCreateLabel("Granted Date", 40, 85, 68, 17)
  $afrmNew[5][0] = "$inpGrantedDate"
  $afrmNew[5][1] = GUICtrlCreateInput("2005/10/18", 130, 80, 76, 21, BitOR($ES_RIGHT,$ES_READONLY), $WS_EX_CLIENTEDGE)
	GUICtrlCreateLabel("Amount", 225, 85, 40, 17)
  $afrmNew[6][0] = "$inpAmount"
  $afrmNew[6][1] = GUICtrlCreateInput("10,000,000", 310, 80, 76, 21, BitOR($ES_RIGHT,$ES_READONLY), $WS_EX_CLIENTEDGE)
	GUICtrlCreateLabel("Accepted Date", 40, 110, 76, 17)
  $afrmNew[7][0] = "$inpAcceptedDate"
  $afrmNew[7][1] = GUICtrlCreateInput("2006/10/21", 130, 105, 76, 21, BitOR($ES_RIGHT,$ES_READONLY), $WS_EX_CLIENTEDGE)
	GUICtrlCreateLabel("Registered Date", 220, 110, 81, 17)
  $afrmNew[8][0] = "$inpRegisteredDate"
  $afrmNew[8][1] = GUICtrlCreateInput("2006/12/03", 310, 105, 76, 21, BitOR($ES_RIGHT,$ES_READONLY), $WS_EX_CLIENTEDGE)
	GUICtrlCreateLabel("Release Date", 40, 135, 69, 17)
  $afrmNew[9][0] = "$inpReleaseDate"
  $afrmNew[9][1] = GUICtrlCreateInput("2005/03/10", 130, 130, 76, 21, BitOR($ES_RIGHT,$ES_READONLY), $WS_EX_CLIENTEDGE)
	GUICtrlCreateGroup("", -99, -99, 1, 1)
	GUICtrlCreateGroup("Clients linked to Loan Account", 410, 10, 371, 151)
	GUICtrlSetFont(-1, 8, 800, 0, "MS Sans Serif")
  $afrmNew[10][0] = "$lvClients"
  $afrmNew[10][1] = GUICtrlCreateListView("Number  |Name                                  |Insurable|PolicyNr", 420, 35, 341, 111)
	GUICtrlCreateGroup("", -99, -99, 1, 1)

	;Tab control
	GUICtrlCreateTab(5, 165, 776, 321)
	GUICtrlCreateTabItem("Released Person Details")
	
	GUICtrlCreateGroup("Capital and Premium details", 15, 200, 751, 276)
	GUICtrlSetFont(-1, 8, 800, 0, "MS Sans Serif")
	GUICtrlCreateLabel("Balance Capital as at", 30, 225, 104, 17)
  $afrmNew[11][0] = "$inpBalCapAtDate"
  $afrmNew[11][1] = GUICtrlCreateInput("2004/05/15", 285, 220, 76, 21, -1, $WS_EX_CLIENTEDGE)
  $afrmNew[12][0] = "$inpBalCapAsAt"
  $afrmNew[12][1] = GUICtrlCreateInput("123,336.33", 580, 220, 91, 21, $ES_RIGHT, $WS_EX_CLIENTEDGE)
  $afrmNew[13][0] = "$inpFactor"
  $afrmNew[13][1] = GUICtrlCreateInput("66.666%", 30, 245, 41, 21, BitOR($ES_RIGHT,$ES_READONLY), $WS_EX_CLIENTEDGE)
	GUICtrlCreateLabel("% share of balance capital", 75, 250, 128, 17)
  $afrmNew[14][0] = "$inpShareOfBalCap"
  $afrmNew[14][1] = GUICtrlCreateInput("82,224.22", 580, 245, 91, 21, $ES_RIGHT, $WS_EX_CLIENTEDGE)
	GUICtrlCreateLabel("Capital taken over", 110, 275, 90, 17)
  $afrmNew[15][0] = "$inpCapTakenOverAmt"
  $afrmNew[15][1] = GUICtrlCreateInput("41,112.11", 580, 270, 91, 21, $ES_RIGHT, $WS_EX_CLIENTEDGE)
	GUICtrlCreateLabel("Less: o/a Captial", 111, 300, 84, 17)
  $afrmNew[16][0] = "$inpTotCapTakenOver"
  $afrmNew[16][1] = GUICtrlCreateInput("A0.00", 580, 295, 91, 21, $ES_RIGHT, $WS_EX_CLIENTEDGE)
	GUICtrlCreateLabel("Captital to be taken over", 110, 325, 120, 17)
  $afrmNew[17][0] = "$inpCapToBeTakenOverDate"
  $afrmNew[17][1] = GUICtrlCreateInput("2005/03/10", 400, 320, 76, 21, -1, $WS_EX_CLIENTEDGE)
  $afrmNew[18][0] = "$inpCapToBeTakenOverAmt"
  $afrmNew[18][1] = GUICtrlCreateInput("A41,112.11", 580, 320, 91, 21, $ES_RIGHT, $WS_EX_CLIENTEDGE)
	GUICtrlCreateLabel("Premium of released client", 30, 365, 127, 17)
  $afrmNew[19][0] = "$inpPremOfRelClient"
  $afrmNew[19][1] = GUICtrlCreateInput("0.00", 580, 360, 91, 21, $ES_RIGHT, $WS_EX_CLIENTEDGE)
	GUICtrlCreateLabel("Total amount of days until date of registration", 30, 390, 215, 17)
  $afrmNew[20][0] = "$inpDaysToReg"
  $afrmNew[20][1] = GUICtrlCreateInput("299", 640, 385, 31, 21, $ES_RIGHT, $WS_EX_CLIENTEDGE)
	GUICtrlCreateLabel("Premium Payable", 110, 425, 127, 17)
	GUICtrlSetFont(-1, 8, 800, 0, "MS Sans Serif")
  $afrmNew[21][0] = "$inpPremPayDate"
  $afrmNew[21][1] = GUICtrlCreateInput("2005/03/10", 400, 420, 76, 21, -1, $WS_EX_CLIENTEDGE)
  $afrmNew[22][0] = "$inpPremRelClient"
  $afrmNew[22][1] = GUICtrlCreateInput("61,668,17", 580, 420, 91, 21, $ES_RIGHT, $WS_EX_CLIENTEDGE)
	GUICtrlCreateGroup("", -99, -99, 1, 1)
	
	GUICtrlCreateTabItem("Clients taking over Capital")
	GUICtrlCreateGroup("Calculation of remaining Clients portion", 15, 200, 366, 276)
	GUICtrlSetFont(-1, 8, 800, 0, "MS Sans Serif")
	GUICtrlCreateLabel("Clients Date of Birth", 40, 225, 97, 17)
	$afrmNew[23][0] = "$inpDOB"
	$afrmNew[23][1] = GUICtrlCreateInput("2004/05/15", 265, 220, 76, 21, -1, $WS_EX_CLIENTEDGE)
	GUICtrlCreateLabel("Age next Birthday", 40, 250, 87, 17)
	$afrmNew[24][0] = "$inpAgeNB"
	$afrmNew[24][1] = GUICtrlCreateInput("68", 265, 245, 31, 21, $ES_RIGHT, $WS_EX_CLIENTEDGE)
	GUICtrlCreateLabel("Remaining period of Loan", 40, 275, 125, 17)
	$afrmNew[25][0] = "$inpOSTerm"
	$afrmNew[25][1] = GUICtrlCreateInput("10", 265, 270, 31, 21, $ES_RIGHT, $WS_EX_CLIENTEDGE)
	GUICtrlCreateLabel("Factor (%)", 40, 300, 51, 17)
	$afrmNew[26][0] = "$inpFactor"
	$afrmNew[26][1] = GUICtrlCreateInput("0.00", 265, 295, 51, 21, $ES_RIGHT, $WS_EX_CLIENTEDGE)
	GUICtrlCreateLabel("Remaining Clients Portion", 35, 325, 182, 20)
	GUICtrlSetFont(-1, 10, 800, 0, "MS Sans Serif")
	GUICtrlCreateLabel("Balance Capital as at", 40, 350, 104, 17)
	$afrmNew[27][0] = "$inpBalCapAsAtDate"
	$afrmNew[27][1] = GUICtrlCreateInput("2004/05/15", 170, 345, 76, 21, -1, $WS_EX_CLIENTEDGE)
	$afrmNew[28][0] = "$inpBalCapAsAtAmt"
	$afrmNew[28][1] = GUICtrlCreateInput("41,112.11", 265, 345, 91, 21, $ES_RIGHT, $WS_EX_CLIENTEDGE)
	GUICtrlCreateLabel("Capital taken over as at", 40, 375, 116, 17)
	$afrmNew[29][0] = "$inpDateCapTakenOver"
	$afrmNew[29][1] = GUICtrlCreateInput("2005/03/10", 170, 370, 76, 21, -1, $WS_EX_CLIENTEDGE)
	$afrmNew[30][0] = "$inpCapTakenOverAmt"
	$afrmNew[30][1] = GUICtrlCreateInput("20,556.06", 265, 370, 91, 21, $ES_RIGHT, $WS_EX_CLIENTEDGE)
	GUICtrlCreateLabel("New Balance Capital", 50, 400, 122, 17)
	GUICtrlSetFont(-1, 8, 800, 0, "MS Sans Serif")
	$afrmNew[31][0] = "$inpNewBalCapital"
	$afrmNew[31][1] = GUICtrlCreateInput("61,668,17", 265, 395, 91, 21, $ES_RIGHT, $WS_EX_CLIENTEDGE)
	GUICtrlCreateGroup("", -99, -99, 1, 1)

	GUICtrlCreateGroup("Insurance Certificate", 390, 200, 386, 271)
	GUICtrlSetFont(-1, 10, 800, 0, "MS Sans Serif")
	GUICtrlCreateLabel("New Balance Capital", 420, 225, 103, 17)
	$afrmNew[32][0] = "$inpNewBalCap"
	$afrmNew[32][1] = GUICtrlCreateInput("61,668.17", 652, 220, 91, 21, $ES_RIGHT, $WS_EX_CLIENTEDGE)
	GUICtrlCreateLabel("Premiums Value", 420, 250, 79, 17)
	$afrmNew[33][0] = "$inpPremValue"
	$afrmNew[33][1] = GUICtrlCreateInput("55,500.00", 652, 245, 91, 21, $ES_RIGHT, $WS_EX_CLIENTEDGE)
	GUICtrlCreateLabel("Additional insurance certificate", 420, 275, 180, 17)
	GUICtrlSetFont(-1, 8, 800, 0, "MS Sans Serif")
	$afrmNew[34][0] = "$inpAddInsCertificate"
	$afrmNew[34][1] = GUICtrlCreateInput("0.00", 652, 270, 91, 21, $ES_RIGHT, $WS_EX_CLIENTEDGE)
	GUICtrlCreateLabel("Remaining Clients insurance premium", 420, 300, 179, 17)
	$afrmNew[35][0] = "$inpRemClientPrem"
	$afrmNew[35][1] = GUICtrlCreateInput("1,057.00", 652, 295, 91, 21, $ES_RIGHT, $WS_EX_CLIENTEDGE)
	GUICtrlCreateLabel("Premium on capital taken over", 420, 325, 147, 17)
	$afrmNew[36][0] = "$inpPremOnCapTakenOver"
	$afrmNew[36][1] = GUICtrlCreateInput("0.00", 652, 320, 91, 21, $ES_RIGHT, $WS_EX_CLIENTEDGE)
	GUICtrlCreateLabel("ANNUAL PREMIUM", 420, 350, 116, 17)
	GUICtrlSetFont(-1, 8, 800, 0, "MS Sans Serif")
	$afrmNew[37][0] = "$inpAnnualPrem"
	$afrmNew[37][1] = GUICtrlCreateInput("1,057.00", 652, 345, 91, 21, $ES_RIGHT, $WS_EX_CLIENTEDGE)
	GUICtrlCreateLabel("Current Annual Premium", 420, 380, 117, 17)
	$afrmNew[38][0] = "$inpCurrAnnualPremium"
	$afrmNew[38][1] = GUICtrlCreateInput("1,057.00", 652, 375, 91, 21, $ES_RIGHT, $WS_EX_CLIENTEDGE)
	GUICtrlCreateLabel("Premium from registration date to next due date", 420, 405, 225, 17)
	$afrmNew[39][0] = "$inpPremRegToNDD"
	$afrmNew[39][1] = GUICtrlCreateInput("0.00", 652, 400, 91, 21, $ES_RIGHT, $WS_EX_CLIENTEDGE)
	GUICtrlCreateGroup("", -99, -99, 1, 1)
	;Close Tab Control
	GUICtrlCreateTabitem ("")   ; end tab definition

	;Close button - if added below, it forms part of the last created tabitem
	$afrmNew[40][0] = "$btnClose"
	$afrmNew[40][1] = GUICtrlCreateButton("Close", 675, 490, 106, 26)

EndFunc

Func frmRelease_WndProc()
	
	Select
		Case $msg[0] = $GUI_EVENT_CLOSE
			GUISwitch(_GetCtrl("$frmParent", $afrmRelease))
			GUISetState(@SW_ENABLE)
			GUISwitch($afrmRelease[0][1])
			GUISetState(@SW_HIDE)
		Case $msg[0] = _GetCtrl("$btnClose", $afrmRelease)
			$msg[0] = $GUI_EVENT_CLOSE
			frmRelease_WndProc()
    EndSelect

EndFunc

;~ ;Dummy Initialize
;~ Func frmRelease_Initialize()
;~ EndFunc

Func frmRelease_Initialize()
	Local $sSql, $aRow, $hQuery, $sqlError
	
	$sSql = "select ProductCode, LoanTerm, DateGranted, GrantedAmount, "
	$sSql &= "DateAccepted, RegistrationDate from Accounts where Branch='"
	$sSql &= GUICtrlRead(_GetCtrl("$inpBranch", $afrmTestTx))
	$sSql &= "' and AccountNumber='"
	$sSql &= GUICtrlRead(_GetCtrl("$inpAccount", $afrmTestTx)) & "' "
	$sSql &= " order by EffDate DESC, EffSeq DESC limit 1;"
	
	_SQlite_Query ($hSQLite, $sSql, $hQuery) ; the query
	If _SQLite_FetchData ($hQuery, $aRow) = $SQLITE_OK Then
		;aRow[0]-ProductCode, aRow[1]-LoanTerm, aRow[2]-DateGranted
		;aRow[3]-GranterdAmount, aRow[4]-DateAccepted, aRow[5]-DateRegistered
		GUICtrlSetData(_GetCtrl("$inpProduct", $afrmRelease), $aRow[0])
		GUICtrlSetData(_GetCtrl("$inpTerm", $afrmRelease), $aRow[1])
		GUICtrlSetData(_GetCtrl("$inpGrantedDate", $afrmRelease), StringLeft($aRow[2],4)&"/"&StringMid($aRow[2],5,2)&"/"&StringRight($aRow[2],2))
		GUICtrlSetData(_GetCtrl("$inpAmount", $afrmRelease), _StringCurrencyFormat($aRow[3]))
		GUICtrlSetData(_GetCtrl("$inpAcceptedDate", $afrmRelease), StringLeft($aRow[4],4)&"/"&StringMid($aRow[4],5,2)&"/"&StringRight($aRow[4],2))
		GUICtrlSetData(_GetCtrl("$inpRegisteredDate", $afrmRelease), StringLeft($aRow[5],4)&"/"&StringMid($aRow[5],5,2)&"/"&StringRight($aRow[5],2))
	EndIf
	GUICtrlSetData(_GetCtrl("$inpReleaseDate", $afrmRelease), _
								GUICtrlRead(_GetCtrl("$inpPar7", $afrmTestTx)))

	;Setup Release transaction variables
;Global $gRelNoClients, $gRelPercOSCap, $gRelClientBalOfCap, $gRelCapTakenOver
;Global $gRelReleaseClientNewCap, $gRelReleasedClientCap, $gRelClientRemainingCap
;Global $gRelPremOfReleasedClient, $gRelDaysToRelease, 
	;Get Loan Account Record

	;Set up the Loan Account Details
	GUICtrlSetData(_GetCtrl("$inpLoanAccount", $afrmRelease), _
								GUICtrlRead(_GetCtrl("$inpBranch", $afrmTestTx)) & "/" & _
								StringFormat("%d", GUICtrlRead(_GetCtrl("$inpAccount", $afrmTestTx))) )
	
	$gRelNoClients = GetNoOfClients()
	AddClientsToListView(_GetCtrl("$lvClients", $afrmRelease))
;	GUICtrlSetData(_GetCtrl("$inpTable", $afrmTestTx),"Clients")
EndFunc

Func GetNoOfClients()
	Local $sSql, $aRow, $hQuery, $sqlError
	
	$sSql = "select count(*) from ("
	$sSql &="select distinct am.ClientNumber "
	$sSql &="from AccMembers am "
	$sSql &="join Accounts a on (a.Branch=am.Branch and a.AccountNumber=am.AccountNumber) "
	$sSql &="where a.AccountStatus='OPEN' and am.Branch='"
	$sSql &=GUICtrlRead(_GetCtrl("$inpBranch", $afrmTestTx))
	$sSql &="' and am.AccountNumber='"
	$sSql &=GUICtrlRead(_GetCtrl("$inpAccount", $afrmTestTx)) & "'"
	$sSql &=") as t1;"
	
	_SQlite_Query ($hSQLite, $sSql, $hQuery) ; the query
	while _SQLite_FetchData ($hQuery, $aRow) = $SQLITE_OK
		MsgBox(0,"No of Clients",$aRow[0])
	WEnd
	
	return $aRow[0]
EndFunc

Func AddClientsToListView($hLV)
	Local $nNoOfClients, $sSql, $aRow, $hQuery

  $sSql &= "SELECT distinct am.ClientNumber, c.Name, am.IsInsurable, p.PolicyNumber "
  $sSql &= "from AccMembers am "
  $sSql &= "join Clients c on (c.ClientNumber=am.ClientNumber) "
  $sSql &= "join Accounts a on (a.Branch=am.Branch and a.AccountNumber=am.AccountNumber) "
	$sSql &= "left outer join Policies p on (p.Branch=am.Branch and p.AccountNumber=am.AccountNumber and p.ClientNumber=am.ClientNumber) "
  $sSql &= "where a.AccountStatus='OPEN' and am.Branch='"
	$sSql &=GUICtrlRead(_GetCtrl("$inpBranch", $afrmTestTx))
  $sSql &= "' and am.AccountNumber='"
	$sSql &=GUICtrlRead(_GetCtrl("$inpAccount", $afrmTestTx))
  $sSql &= "';"

	_SQlite_Query ($hSQLite, $sSql, $hQuery) ; the query
	while _SQLite_FetchData ($hQuery, $aRow) = $SQLITE_OK
		GUICtrlCreateListViewItem($aRow[0] & "|" & $aRow[1] & "|" & $aRow[2] & "|" & StringFormat("%d", $aRow[3]), _GetCtrl("$lvClients", $afrmRelease))
	WEnd
	
EndFunc
