;==============================================================================
;
; Module:          frmTestTx.au3
; Description:     Allows the user to test the different transactions
;                  that will be received from the SAP Interface.
; Parameters:      None
; Requirement(s):  A Landbank.db SQLite database
;                  OLEDB drivers for MS-Excel.
; Return Value(s): None 
; Author(s):       DJ van Vliet
; Note(s):          
;==============================================================================

Func CreateForm_frmTestTx(ByRef $afrmNew, $frmParent)
	Dim $afrmNew[29][2]

  $afrmNew[0][0] = "$frmTestTx"
	$afrmNew[0][1] = GUICreate("Test Land Bank Transactions", 538, 305, -1, -1, -1, -1, $frmParent)

	$afrmNew[1][0] = "$frmParent"
	$afrmNew[1][1] = $frmParent
	
  GUICtrlCreateGroup("Select Transaction", 10, 18, 192, 240)
;	GUICtrlCreateGroup("", -99, -99, 1, 1)

	$afrmNew[2][0] = "$rbRelease"
	$afrmNew[2][1] = GUICtrlCreateRadio("Release ", 35, 37, 130, 17)
  GUICtrlSetState(-1, $GUI_CHECKED)
	$afrmNew[3][0] = "$rbSubstitution"
	$afrmNew[3][1] = GUICtrlCreateRadio("Substitution", 35, 57, 130, 17)

	$afrmNew[4][0] = "$rbAtlDueDate"
	$afrmNew[4][1] = GUICtrlCreateRadio("Alteration of Due Date", 35, 77, 130, 17)
	$afrmNew[5][0] = "$rbSCR"
	$afrmNew[5][1] = GUICtrlCreateRadio("Special Captial Repayment", 35, 97, 150, 17)
	$afrmNew[6][0] = "$rbUnexpBal"
	$afrmNew[6][1] = GUICtrlCreateRadio("Unexpended Balance", 35, 117, 130, 17)
	$afrmNew[7][0] = "$rbLoanXfer"
	$afrmNew[7][1] = GUICtrlCreateRadio("Loan Transfer", 35, 137, 130, 17)
;	 GUICtrlSetState(-1, $GUI_DISABLE)
	$afrmNew[8][0] = "$rbClaim"
	$afrmNew[8][1] = GUICtrlCreateRadio("Death Claim", 35, 157, 113, 17)
;  GUICtrlSetState(-1, $GUI_DISABLE)
	$afrmNew[9][0] = "$rbFinLoan"
	$afrmNew[9][1] = GUICtrlCreateRadio("Finish Loan", 35, 177, 113, 17)
;  GUICtrlSetState(-1, $GUI_DISABLE)
	$afrmNew[10][0] = "$rbNewLoan"
	$afrmNew[10][1] = GUICtrlCreateRadio("New Loan", 35, 197, 130, 17)
	GUICtrlCreateGroup("Parameters", 210, 18, 311, 240)
	GUICtrlCreateGroup("", -99, -99, 1, 1)

	$afrmNew[11][0] = "$lblBranch"
	$afrmNew[11][1] = GUICtrlCreateLabel("Branch", 225, 40, 164, 17)
	$afrmNew[12][0] = "$lblAccount"
	$afrmNew[12][1] = GUICtrlCreateLabel("Account", 225, 65, 164, 17)
	$afrmNew[13][0] = "$lblClient"
	$afrmNew[13][1] = GUICtrlCreateLabel("Client", 225, 90, 164, 17)
	$afrmNew[14][0] = "$lblLDD"
	$afrmNew[14][1] = GUICtrlCreateLabel("Last Due Date", 225, 115, 164, 17)
	$afrmNew[15][0] = "$lblPar5"
	$afrmNew[15][1] = GUICtrlCreateLabel("O/S Capital at Last Due Date", 225, 140, 164, 17)
	$afrmNew[16][0] = "$lblPar6"
	$afrmNew[16][1] = GUICtrlCreateLabel("Cap Pay after Last Due Date (DRE)", 225, 165, 170, 17)
	$afrmNew[17][0] = "$lblPar7"
	$afrmNew[17][1] = GUICtrlCreateLabel("Release Date", 225, 190, 164, 17)
	$afrmNew[18][0] = "$lblPar8"
	$afrmNew[18][1] = GUICtrlCreateLabel("Payment Release Amount written off Capital", 225, 215, 164, 40)
	
	$afrmNew[19][0] = "$inpBranch"
	$afrmNew[19][1] = GUICtrlCreateInput("", 400,  38,  56, 21, -1, $WS_EX_CLIENTEDGE)
	$afrmNew[20][0] = "$inpAccount"
	$afrmNew[20][1] = GUICtrlCreateInput("", 400,  63, 111, 21, -1, $WS_EX_CLIENTEDGE)
	$afrmNew[21][0] = "$inpClient"
	$afrmNew[21][1] = GUICtrlCreateInput("", 400,  88,  81, 21, -1, $WS_EX_CLIENTEDGE)
	$afrmNew[22][0] = "$inpLDD"
	$afrmNew[22][1] = GUICtrlCreateInput("", 400, 113,  81, 21, -1, $WS_EX_CLIENTEDGE)
  
	$afrmNew[23][0] = "$inpPar5"
	$afrmNew[23][1] = GUICtrlCreateInput("", 400, 138,  81, 21, -1, $WS_EX_CLIENTEDGE)
	$afrmNew[24][0] = "$inpPar6"
	$afrmNew[24][1] = GUICtrlCreateInput("", 400, 163,  81, 21, -1, $WS_EX_CLIENTEDGE)
	$afrmNew[25][0] = "$inpPar7"
	$afrmNew[25][1] = GUICtrlCreateInput("", 400, 188,  81, 21, -1, $WS_EX_CLIENTEDGE)
	$afrmNew[26][0] = "$inpPar8"
	$afrmNew[26][1] = GUICtrlCreateInput("", 400, 213,  81, 21, -1, $WS_EX_CLIENTEDGE)

	$afrmNew[27][0] = "$btnCalculate"
	$afrmNew[27][1] = GUICtrlCreateButton("&Calculate", 10, 270, 106, 26)
	$afrmNew[28][0] = "$btnClose"
	$afrmNew[28][1] = GUICtrlCreateButton("Close", 414, 270, 106, 26)

EndFunc

Func frmTestTx_WndProc()
	
	Select
		Case $msg[0] = $GUI_EVENT_CLOSE
			GUISwitch(_GetCtrl("$frmParent", $afrmTestTx))
			GUISetState(@SW_ENABLE)
			GUISwitch($afrmTestTx[0][1])
			GUISetState(@SW_HIDE)
		Case $msg[0] = _GetCtrl("$btnClose", $afrmTestTx)
			$msg[0] = $GUI_EVENT_CLOSE
			frmTestTx_WndProc()
		Case $msg[0] = _GetCtrl("$btnCalculate", $afrmTestTx)
			frmTestTx_btnCalculate_Click()

		Case $msg[0] = _GetCtrl("$rbRelease", $afrmTestTx) And BitAND(GUICtrlRead(_GetCtrl("$rbRelease", $afrmTestTx)), $GUI_CHECKED) = $GUI_CHECKED
			;Change Label Descriptions 
				frmTestTx_ShowRelease()
		Case $msg[0] = _GetCtrl("$rbSubstitution", $afrmTestTx) And BitAND(GUICtrlRead(_GetCtrl("$rbSubstitution", $afrmTestTx)), $GUI_CHECKED) = $GUI_CHECKED
				frmTestTx_ShowSubstitution()
		Case $msg[0] = _GetCtrl("$rbAtlDueDate", $afrmTestTx) And BitAND(GUICtrlRead(_GetCtrl("$rbAtlDueDate", $afrmTestTx)), $GUI_CHECKED) = $GUI_CHECKED
				frmTestTx_ShowAtLDueDate()
		Case $msg[0] = _GetCtrl("$rbSCR", $afrmTestTx) And BitAND(GUICtrlRead(_GetCtrl("$rbSCR", $afrmTestTx)), $GUI_CHECKED) = $GUI_CHECKED
				frmTestTx_ShowSCR()
		Case $msg[0] = _GetCtrl("$rbUnexpBal", $afrmTestTx) And BitAND(GUICtrlRead(_GetCtrl("$rbUnexpBal", $afrmTestTx)), $GUI_CHECKED) = $GUI_CHECKED
				frmTestTx_ShowUnexpBal()
		Case $msg[0] = _GetCtrl("$rbLoanXfer", $afrmTestTx) And BitAND(GUICtrlRead(_GetCtrl("$rbLoanXfer", $afrmTestTx)), $GUI_CHECKED) = $GUI_CHECKED
				frmTestTx_ShowLoanXfer()
		Case $msg[0] = _GetCtrl("$rbClaim", $afrmTestTx) And BitAND(GUICtrlRead(_GetCtrl("$rbClaim", $afrmTestTx)), $GUI_CHECKED) = $GUI_CHECKED
				frmTestTx_ShowClaim()
		Case $msg[0] = _GetCtrl("$rbFinLoan", $afrmTestTx) And BitAND(GUICtrlRead(_GetCtrl("$rbFinLoan", $afrmTestTx)), $GUI_CHECKED) = $GUI_CHECKED
				frmTestTx_ShowFinLoan()
		Case $msg[0] = _GetCtrl("$btnCalculate", $afrmTestTx)
			frmTestTx_btnCalculate_Click()
    EndSelect

EndFunc

Func frmTestTx_Initialize()
;	GUICtrlSetData(_GetCtrl("$inpTable", $afrmTestTx),"Clients")
EndFunc

Func frmTestTx_ShowRelease()
	GUICtrlSetData(_GetCtrl("$lblBranch", $afrmTestTx), "Branch")
	GUICtrlSetData(_GetCtrl("$lblAccount", $afrmTestTx), "Account")
	GUICtrlSetData(_GetCtrl("$lblClient", $afrmTestTx), "Client")
	GUICtrlSetData(_GetCtrl("$lblLDD", $afrmTestTx), "Last Due Date")
	GUICtrlSetData(_GetCtrl("$lblPar5", $afrmTestTx), "O/S Capital at Last Due Date")
	GUICtrlSetData(_GetCtrl("$lblPar6", $afrmTestTx), "Cap Pay after Last Due Date (DRE)")
	GUICtrlSetData(_GetCtrl("$lblPar7", $afrmTestTx), "Release Date")
	GUICtrlSetData(_GetCtrl("$lblPar8", $afrmTestTx), "Payment Release Amount written off Capital")
	GUICtrlSetState(_GetCtrl("$lblPar5", $afrmTestTx), $GUI_SHOW)
	GUICtrlSetState(_GetCtrl("$lblPar6", $afrmTestTx), $GUI_SHOW)
	GUICtrlSetState(_GetCtrl("$lblPar7", $afrmTestTx), $GUI_SHOW)
	GUICtrlSetState(_GetCtrl("$lblPar8", $afrmTestTx), $GUI_SHOW)
	GUICtrlSetState(_GetCtrl("$inpPar5", $afrmTestTx), $GUI_SHOW)
	GUICtrlSetState(_GetCtrl("$inpPar6", $afrmTestTx), $GUI_SHOW)
	GUICtrlSetState(_GetCtrl("$inpPar7", $afrmTestTx), $GUI_SHOW)
	GUICtrlSetState(_GetCtrl("$inpPar8", $afrmTestTx), $GUI_SHOW)
	GUICtrlSetData(_GetCtrl("$inpPar5", $afrmTestTx), "")
	GUICtrlSetData(_GetCtrl("$inpPar6", $afrmTestTx), "")
	GUICtrlSetData(_GetCtrl("$inpPar7", $afrmTestTx), "")
	GUICtrlSetData(_GetCtrl("$inpPar8", $afrmTestTx), "")
EndFunc
Func frmTestTx_ShowSubstitution()
	GUICtrlSetData(_GetCtrl("$lblBranch", $afrmTestTx), "Branch")
	GUICtrlSetData(_GetCtrl("$lblAccount", $afrmTestTx), "Account")
	GUICtrlSetData(_GetCtrl("$lblClient", $afrmTestTx), "Client - Current")
	GUICtrlSetData(_GetCtrl("$lblLDD", $afrmTestTx), "Last Due Date")
	GUICtrlSetData(_GetCtrl("$lblPar5", $afrmTestTx), "Client - New")
	GUICtrlSetData(_GetCtrl("$lblPar6", $afrmTestTx), "Substitution Date")
	GUICtrlSetData(_GetCtrl("$lblPar7", $afrmTestTx), "")
	GUICtrlSetData(_GetCtrl("$lblPar8", $afrmTestTx), "")
	GUICtrlSetState(_GetCtrl("$lblPar5", $afrmTestTx), $GUI_SHOW)
	GUICtrlSetState(_GetCtrl("$lblPar6", $afrmTestTx), $GUI_SHOW)
	GUICtrlSetState(_GetCtrl("$lblPar7", $afrmTestTx), $GUI_HIDE)
	GUICtrlSetState(_GetCtrl("$lblPar8", $afrmTestTx), $GUI_HIDE)
	GUICtrlSetState(_GetCtrl("$inpPar5", $afrmTestTx), $GUI_SHOW)
	GUICtrlSetState(_GetCtrl("$inpPar6", $afrmTestTx), $GUI_SHOW)
	GUICtrlSetState(_GetCtrl("$inpPar7", $afrmTestTx), $GUI_HIDE)
	GUICtrlSetState(_GetCtrl("$inpPar8", $afrmTestTx), $GUI_HIDE)
	GUICtrlSetData(_GetCtrl("$inpPar5", $afrmTestTx), "")
	GUICtrlSetData(_GetCtrl("$inpPar6", $afrmTestTx), "")
	GUICtrlSetData(_GetCtrl("$inpPar7", $afrmTestTx), "")
	GUICtrlSetData(_GetCtrl("$inpPar8", $afrmTestTx), "")
EndFunc
Func frmTestTx_ShowAtLDueDate()
	GUICtrlSetData(_GetCtrl("$lblBranch", $afrmTestTx), "Branch")
	GUICtrlSetData(_GetCtrl("$lblAccount", $afrmTestTx), "Account")
	GUICtrlSetData(_GetCtrl("$lblClient", $afrmTestTx), "Client")
	GUICtrlSetData(_GetCtrl("$lblLDD", $afrmTestTx), "Last Due Date")
	GUICtrlSetData(_GetCtrl("$lblPar5", $afrmTestTx), "New Due Date")
	GUICtrlSetData(_GetCtrl("$lblPar6", $afrmTestTx), "")
	GUICtrlSetData(_GetCtrl("$lblPar7", $afrmTestTx), "")
	GUICtrlSetData(_GetCtrl("$lblPar8", $afrmTestTx), "")
	GUICtrlSetState(_GetCtrl("$lblPar5", $afrmTestTx), $GUI_SHOW)
	GUICtrlSetState(_GetCtrl("$lblPar6", $afrmTestTx), $GUI_HIDE)
	GUICtrlSetState(_GetCtrl("$lblPar7", $afrmTestTx), $GUI_HIDE)
	GUICtrlSetState(_GetCtrl("$lblPar8", $afrmTestTx), $GUI_HIDE)
	GUICtrlSetState(_GetCtrl("$inpPar5", $afrmTestTx), $GUI_SHOW)
	GUICtrlSetState(_GetCtrl("$inpPar6", $afrmTestTx), $GUI_HIDE)
	GUICtrlSetState(_GetCtrl("$inpPar7", $afrmTestTx), $GUI_HIDE)
	GUICtrlSetState(_GetCtrl("$inpPar8", $afrmTestTx), $GUI_HIDE)
	GUICtrlSetData(_GetCtrl("$inpPar5", $afrmTestTx), "")
	GUICtrlSetData(_GetCtrl("$inpPar6", $afrmTestTx), "")
	GUICtrlSetData(_GetCtrl("$inpPar7", $afrmTestTx), "")
	GUICtrlSetData(_GetCtrl("$inpPar8", $afrmTestTx), "")
EndFunc
Func frmTestTx_ShowSCR()
	GUICtrlSetData(_GetCtrl("$lblBranch", $afrmTestTx), "Branch")
	GUICtrlSetData(_GetCtrl("$lblAccount", $afrmTestTx), "Account")
	GUICtrlSetData(_GetCtrl("$lblClient", $afrmTestTx), "Client")
	GUICtrlSetData(_GetCtrl("$lblLDD", $afrmTestTx), "Last Due Date / Prev SRC Date")
	GUICtrlSetData(_GetCtrl("$lblPar5", $afrmTestTx), "")
	GUICtrlSetData(_GetCtrl("$lblPar6", $afrmTestTx), "")
	GUICtrlSetData(_GetCtrl("$lblPar7", $afrmTestTx), "")
	GUICtrlSetData(_GetCtrl("$lblPar8", $afrmTestTx), "")
	GUICtrlSetState(_GetCtrl("$lblPar5", $afrmTestTx), $GUI_HIDE)
	GUICtrlSetState(_GetCtrl("$lblPar6", $afrmTestTx), $GUI_HIDE)
	GUICtrlSetState(_GetCtrl("$lblPar7", $afrmTestTx), $GUI_HIDE)
	GUICtrlSetState(_GetCtrl("$lblPar8", $afrmTestTx), $GUI_HIDE)
	GUICtrlSetState(_GetCtrl("$inpPar5", $afrmTestTx), $GUI_HIDE)
	GUICtrlSetState(_GetCtrl("$inpPar6", $afrmTestTx), $GUI_HIDE)
	GUICtrlSetState(_GetCtrl("$inpPar7", $afrmTestTx), $GUI_HIDE)
	GUICtrlSetState(_GetCtrl("$inpPar8", $afrmTestTx), $GUI_HIDE)
	GUICtrlSetData(_GetCtrl("$inpPar5", $afrmTestTx), "")
	GUICtrlSetData(_GetCtrl("$inpPar6", $afrmTestTx), "")
	GUICtrlSetData(_GetCtrl("$inpPar7", $afrmTestTx), "")
	GUICtrlSetData(_GetCtrl("$inpPar8", $afrmTestTx), "")
EndFunc
Func frmTestTx_ShowUnexpBal()
	GUICtrlSetData(_GetCtrl("$lblBranch", $afrmTestTx), "Branch")
	GUICtrlSetData(_GetCtrl("$lblAccount", $afrmTestTx), "Account")
	GUICtrlSetData(_GetCtrl("$lblClient", $afrmTestTx), "Client")
	GUICtrlSetData(_GetCtrl("$lblLDD", $afrmTestTx), "Last Due Date")
	GUICtrlSetData(_GetCtrl("$lblPar5", $afrmTestTx), "Cancellation Date")
	GUICtrlSetData(_GetCtrl("$lblPar6", $afrmTestTx), "Unexpended Balance")
	GUICtrlSetData(_GetCtrl("$lblPar7", $afrmTestTx), "")
	GUICtrlSetData(_GetCtrl("$lblPar8", $afrmTestTx), "")
	GUICtrlSetState(_GetCtrl("$lblPar5", $afrmTestTx), $GUI_SHOW)
	GUICtrlSetState(_GetCtrl("$lblPar6", $afrmTestTx), $GUI_SHOW)
	GUICtrlSetState(_GetCtrl("$lblPar7", $afrmTestTx), $GUI_HIDE)
	GUICtrlSetState(_GetCtrl("$lblPar8", $afrmTestTx), $GUI_HIDE)
	GUICtrlSetState(_GetCtrl("$inpPar5", $afrmTestTx), $GUI_SHOW)
	GUICtrlSetState(_GetCtrl("$inpPar6", $afrmTestTx), $GUI_SHOW)
	GUICtrlSetState(_GetCtrl("$inpPar7", $afrmTestTx), $GUI_HIDE)
	GUICtrlSetState(_GetCtrl("$inpPar8", $afrmTestTx), $GUI_HIDE)
	GUICtrlSetData(_GetCtrl("$inpPar5", $afrmTestTx), "")
	GUICtrlSetData(_GetCtrl("$inpPar6", $afrmTestTx), "")
	GUICtrlSetData(_GetCtrl("$inpPar7", $afrmTestTx), "")
	GUICtrlSetData(_GetCtrl("$inpPar8", $afrmTestTx), "")
EndFunc
Func frmTestTx_ShowLoanXfer()
	GUICtrlSetData(_GetCtrl("$lblBranch", $afrmTestTx), "Old Branch")
	GUICtrlSetData(_GetCtrl("$lblAccount", $afrmTestTx), "Old Account")
	GUICtrlSetData(_GetCtrl("$lblClient", $afrmTestTx), "New Branch")
	GUICtrlSetData(_GetCtrl("$lblLDD", $afrmTestTx), "New Account")
	GUICtrlSetData(_GetCtrl("$lblPar5", $afrmTestTx), "Transfer Date")
	GUICtrlSetData(_GetCtrl("$lblPar6", $afrmTestTx), "")
	GUICtrlSetData(_GetCtrl("$lblPar7", $afrmTestTx), "")
	GUICtrlSetData(_GetCtrl("$lblPar8", $afrmTestTx), "")
	GUICtrlSetState(_GetCtrl("$lblPar5", $afrmTestTx), $GUI_SHOW)
	GUICtrlSetState(_GetCtrl("$lblPar6", $afrmTestTx), $GUI_HIDE)
	GUICtrlSetState(_GetCtrl("$lblPar7", $afrmTestTx), $GUI_HIDE)
	GUICtrlSetState(_GetCtrl("$lblPar8", $afrmTestTx), $GUI_HIDE)
	GUICtrlSetState(_GetCtrl("$inpPar5", $afrmTestTx), $GUI_SHOW)
	GUICtrlSetState(_GetCtrl("$inpPar6", $afrmTestTx), $GUI_HIDE)
	GUICtrlSetState(_GetCtrl("$inpPar7", $afrmTestTx), $GUI_HIDE)
	GUICtrlSetState(_GetCtrl("$inpPar8", $afrmTestTx), $GUI_HIDE)
	GUICtrlSetData(_GetCtrl("$inpClient", $afrmTestTx), "")
	GUICtrlSetData(_GetCtrl("$inpLDD", $afrmTestTx), "")
	GUICtrlSetData(_GetCtrl("$inpPar5", $afrmTestTx), "")
	GUICtrlSetData(_GetCtrl("$inpPar6", $afrmTestTx), "")
	GUICtrlSetData(_GetCtrl("$inpPar7", $afrmTestTx), "")
	GUICtrlSetData(_GetCtrl("$inpPar8", $afrmTestTx), "")
EndFunc
Func frmTestTx_ShowClaim()
	GUICtrlSetData(_GetCtrl("$lblBranch", $afrmTestTx), "Branch")
	GUICtrlSetData(_GetCtrl("$lblAccount", $afrmTestTx), "Account")
	GUICtrlSetData(_GetCtrl("$lblClient", $afrmTestTx), "Client")
	GUICtrlSetData(_GetCtrl("$lblLDD", $afrmTestTx), "Last Due Date")
	GUICtrlSetData(_GetCtrl("$lblPar5", $afrmTestTx), "Bal of CF at last EOM Run")
	GUICtrlSetData(_GetCtrl("$lblPar6", $afrmTestTx), "Death Date")
	GUICtrlSetData(_GetCtrl("$lblPar7", $afrmTestTx), "Applicable Interest Rate")
	GUICtrlSetData(_GetCtrl("$lblPar8", $afrmTestTx), "")
	GUICtrlSetState(_GetCtrl("$lblPar5", $afrmTestTx), $GUI_SHOW)
	GUICtrlSetState(_GetCtrl("$lblPar6", $afrmTestTx), $GUI_SHOW)
	GUICtrlSetState(_GetCtrl("$lblPar7", $afrmTestTx), $GUI_SHOW)
	GUICtrlSetState(_GetCtrl("$lblPar8", $afrmTestTx), $GUI_HIDE)
	GUICtrlSetState(_GetCtrl("$inpPar5", $afrmTestTx), $GUI_SHOW)
	GUICtrlSetState(_GetCtrl("$inpPar6", $afrmTestTx), $GUI_SHOW)
	GUICtrlSetState(_GetCtrl("$inpPar7", $afrmTestTx), $GUI_SHOW)
	GUICtrlSetState(_GetCtrl("$inpPar8", $afrmTestTx), $GUI_HIDE)
	GUICtrlSetData(_GetCtrl("$inpPar5", $afrmTestTx), "")
	GUICtrlSetData(_GetCtrl("$inpPar6", $afrmTestTx), "")
	GUICtrlSetData(_GetCtrl("$inpPar7", $afrmTestTx), "")
	GUICtrlSetData(_GetCtrl("$inpPar8", $afrmTestTx), "")
EndFunc
Func frmTestTx_ShowFinLoan()
	GUICtrlSetData(_GetCtrl("$lblBranch", $afrmTestTx), "Branch")
	GUICtrlSetData(_GetCtrl("$lblAccount", $afrmTestTx), "Account")
	GUICtrlSetData(_GetCtrl("$lblClient", $afrmTestTx), "Client")
	GUICtrlSetData(_GetCtrl("$lblLDD", $afrmTestTx), "Last Due Date")
	GUICtrlSetData(_GetCtrl("$lblPar5", $afrmTestTx), "O/S Capital at Last Due Date")
	GUICtrlSetData(_GetCtrl("$lblPar6", $afrmTestTx), "Paid up Date")
	GUICtrlSetData(_GetCtrl("$lblPar7", $afrmTestTx), "")
	GUICtrlSetData(_GetCtrl("$lblPar8", $afrmTestTx), "")
	GUICtrlSetState(_GetCtrl("$lblPar5", $afrmTestTx), $GUI_SHOW)
	GUICtrlSetState(_GetCtrl("$lblPar6", $afrmTestTx), $GUI_SHOW)
	GUICtrlSetState(_GetCtrl("$lblPar7", $afrmTestTx), $GUI_HIDE)
	GUICtrlSetState(_GetCtrl("$lblPar8", $afrmTestTx), $GUI_HIDE)
	GUICtrlSetState(_GetCtrl("$inpPar5", $afrmTestTx), $GUI_SHOW)
	GUICtrlSetState(_GetCtrl("$inpPar6", $afrmTestTx), $GUI_SHOW)
	GUICtrlSetState(_GetCtrl("$inpPar7", $afrmTestTx), $GUI_HIDE)
	GUICtrlSetState(_GetCtrl("$inpPar8", $afrmTestTx), $GUI_HIDE)
	GUICtrlSetData(_GetCtrl("$inpPar5", $afrmTestTx), "")
	GUICtrlSetData(_GetCtrl("$inpPar6", $afrmTestTx), "")
	GUICtrlSetData(_GetCtrl("$inpPar7", $afrmTestTx), "")
	GUICtrlSetData(_GetCtrl("$inpPar8", $afrmTestTx), "")
EndFunc


Func frmTestTx_btnCalculate_Click()
	If _GetCtrl("$rbRelease", $afrmTestTx) And BitAND(GUICtrlRead(_GetCtrl("$rbRelease", $afrmTestTx)), $GUI_CHECKED) = $GUI_CHECKED Then
		frmRelease_Initialize()
		; Show frmRelease
		GUISwitch($afrmTestTx[0][1])
		GUISetState(@SW_DISABLE)
		GUISwitch($afrmRelease[0][1])
		GUISetState(@SW_SHOW)
	EndIf
EndFunc


;Func frmTestTx_ValidateLogin($sUserID, $sPassword)
;~ 	Local $ret, $lPassword
;~ 	
;~ 	If StringStripWS($sUserID,3) = "" Then
;~ 		MsgBox(0, "Login","The UserID cannot be blank!")
;~ 		Return False
;~ 	EndIf
;~ 	;If UserID = Supervisor and password = TEBSchemes
;~ 	If StringStripWS(StringUpper($sUserID),3) = "SUPERVISOR" Then
;~ 		If StringStripWS(StringUpper($sPassword),3) = "TEBSCHEMES" Then
;~ 			Return True
;~ 		Else
;~ 			MsgBox(0,"Login Error","Password is incorrect!")
;~ 			Return False
;~ 		EndIf
;~ 	Else
;~ 		;Test for a UserID on the users table
;~ 		$lPassword = $sPassword
;~ 		$ret = SQLite_Validate_UserID($sUserID, $lPassword)
;~ 		If $ret = False Then
;~ 			;User / Password not found / incorrect
;~ 			MsgBox(0,"Login Error","frmTestTx_ValidateLogin - UserID or Password is incorrect!")
;~ 			Return False
;~ 		Else
;~ 			;Valid userID - get previous Server and Database
;~ 			If $sPassword = $lPassword Then
;~ 				Return True
;~ 			Else
;~ 				Return False
;~ 			EndIf
;~ 		EndIf				
;~ 	EndIf

;EndFunc
